#!/usr/bin/perl
# indexsoft access manager
# http://www.indexsoft.com

$|++;
&ReadParameters();
$VER = '2.0 shareware';
$configerror = &CheckConfig();
$document_root = $ENV{'DOCUMENT_ROOT'};
$document_root =~ s/\/$//g;
$document_root =~ s/\//\\/g if ($ENV{'WINDIR'});
$installdir = $ENV{'SCRIPT_FILENAME'};
$installdir =~ s/\/accessmanager.cgi$//g;
$installdir =~ s/\//\\/g if ($ENV{'WINDIR'});

# if save config - save and reload
if (($P{'todo'} eq 'saveconfig') and $P{'cfgfilecontent'})
{
	$P{'cfgfilecontent'} =~ s/\r//g;
	open(FILE, ">accessmanager.pm") || do { print &TopOfPage(); print &HoldError('can not rewrite configuration file <i>\'accessmanager.pm\'</i>'); print &EditConfigForm(); print &BottomOfPage(); exit; };
	binmode('FILE');
	print FILE $P{'cfgfilecontent'};
	close FILE;
	print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nLocation: accessmanager.cgi?todo=configure&saved=1\n\n};
	exit;
}

print &TopOfPage();

# if not configired
if (($P{'todo'} ne 'saveconfig') and ($P{'todo'} ne 'configure') and !$configerror)
{
	# create default .htpasswd
	if (!-e $PassFile or -z $PassFile )
	{
		print &Operation(q{default file with user <i>'administrator'</i> and default password has been created. please change password for <i>'administrator'</i> from <a href="accessmanager.cgi?todo=managehtpasswd">manage users</a>});
		print &HoldError("can not create file <i>'$PassFile'</i>") if (system qq{$ChangeUserCommand -b -c $Encryption "$PassFile" "administrator" "$AdminPassword"});
	}
	# create default .htgroups
	if (!-e $GroupFile)
	{
		print &Operation(q{default file with group <i>'administrators'</i> and member <i>'administrator'</i> has been created});
		open (FILE, ">$GroupFile") || print &HoldError("can not create file <i>'$GroupFile'</i>");
		binmode('FILE');
		print FILE "administrators:administrator\n";
		close(FILE);
	}
	# create default .hthosts
	if (!-e $HostFile or -z $HostFile )
	{
		print &Operation(q{default file with host name <i>'all'</i> has been created});
		open (FILE, ">$HostFile") || print &HoldError("can not create file <i>'$HostFile'</i>");
		binmode('FILE');
		print FILE "all\n";
		close(FILE);
	}
}

# select todo
if (($P{'todo'} eq 'configure') or $configerror)
{
	print &Operation('save configuration file') if $P{'saved'};
	print &EditConfigForm();
}
# hosts
elsif (($P{'todo'} eq 'addhost') and $P{'hostname'})
{
	print &Operation("add new host <i>'$P{'hostname'}'</i>");
	open (FILE, $HostFile);
	@HOSTS = <FILE>;
	close(FILE);
	if (!grep ($_ eq "$P{'hostname'}\n", @HOSTS))
	{
		open (FILE, ">>$HostFile") || print &HoldError("can not write to <i>$HostFile</i>");
		binmode('FILE');
		print FILE "$P{'hostname'}\n";
		close(FILE);
	}
	else { print &HoldError("host '$P{'hostname'}' already exist"); }
	print &ManageHostsForm();
}
elsif (($P{'todo'} eq 'deletehosts') and $P{'hostnames'})
{
	print &Operation('delete selected hosts');
	@HOSTS = split(/\0/,$P{'hostnames'});
	open (FILE, $HostFile);
	foreach $line(<FILE>)
	{
		push (@LINES, $line) if (!grep ("$_\n" eq $line, @HOSTS));
	}
	close(FILE);
	open (FILE, ">$HostFile") || print &HoldError("can not write to <i>$HostFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);

	print &ManageHostsForm();
}
elsif (($P{'todo'} eq 'managehosts') or $P{'from'} eq 'managehosts')
{
	print &ManageHostsForm();
}
elsif (($P{'todo'} eq 'dirwalk'))
{
	if ($P{'createdir'}) { mkdir ("$P{'dir'}$DirSeparator$P{'createdir'}", '0777') || print &HoldError("can not create directory  <i>'$P{'createdir'}'</i>") };
	print &DirWalker($WebRootDir, $P{'dir'});
}
elsif ($P{'todo'} eq 'unprotectdir' and $P{'dir'} and (-e "$P{'dir'}$DirSeparator.htaccess"))
{
	print &Operation(qq{remove protection from directory disabled in shareware version. <a href="http://www.indexsoft.com/passmanagerpro/">please register</a><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>});
	print &StartForm();
}
elsif ($P{'todo'} eq 'edithtaccess' and $P{'dir'})
{
	$htaccesscontent = $htaccessTempl;
	if (-e "$P{'dir'}$DirSeparator.htaccess")
	{
		$htaccesscontent = '';
		open (FILE, "$P{'dir'}$DirSeparator.htaccess") || print &HoldError("can not open file <i>'$P{'dir'}$DirSeparator.htaccess'</i>");
		foreach (<FILE>) { ($htaccesscontent .= $_) if ($_ ne "\n"); }
		close (FILE);
	}
	print &ManageUsersForm($P{'dir'}, $htaccesscontent);
}
elsif ($P{'todo'} eq 'protectdir' and $P{'dir'} and $P{'htaccessfile'})
{
	$P{'htaccessfile'} =~ s/\r//g;
	$P{'htaccessfile'} .= "\n";
	$areaname = $P{'areaname'};
	$areaname = 'Not defined' if !$areaname;
	print &Operation("protect directory <i>'$P{'dir'}'</i> with .htaccess;<br>name of protected area is <i>'$areaname'</i>");
	foreach (split (/\0/, $P{'users'}))	{ $P{'htaccessfile'} .= "require user $_\n" };
	foreach (split (/\0/, $P{'groups'}))	{ $P{'htaccessfile'} .= "require group $_\n" };
	foreach (split (/\0/, $P{'allowhosts'}))	{ $P{'htaccessfile'} .= "Allow from $_\n" };
	foreach (split (/\0/, $P{'denyhosts'}))	{ $P{'htaccessfile'} .= "Deny from $_\n" };
	$P{'htaccessfile'} .= "Satisfy $P{'satisfy'}\n" if ($P{'satisfy'});
	$P{'htaccessfile'} .= "Order $P{'order'}\n" if ($P{'order'});
	$P{'htaccessfile'} .= qq{AuthName "$P{'areaname'}"\n} if $P{'areaname'};
	$P{'htaccessfile'} .= qq{require valid-user\n} if $P{'validuser'};
	open (FILE, ">$P{'dir'}$DirSeparator.htaccess") || print &HoldError("can not create file <i>'$P{'dir'}$DirSeparator.htaccess'</i>");
	binmode('FILE');
	print FILE $P{'htaccessfile'};
	close (FILE);
	print &StartForm($P{'dir'});
}
# all about manage .htpasswd
elsif (($P{'todo'} eq 'adduser') and $P{'username'} and $P{'userpass'})
{
	$P{'username'} =~ s/^#//;
	print &Operation("add new user <i>'$P{'username'}'</i>");
	open (FILE, $PassFile);
	@USERS = <FILE>;
	close(FILE);
	if (!grep (($_ =~ /^$P{'username'}:.*$/ or $_ =~ /^#$P{'username'}:.*$/), @USERS))
	{
		$command = qq{$ChangeUserCommand -b }.((!-e $PassFile)?'-c':'').qq{ $Encryption "$PassFile" "$P{'username'}" "$P{'userpass'}"};
		$code = system "$command";
		print &HoldError("command <i>$command</i> executed with error") if ($code);
	}
	else { $P{'username'} =~ s/^#//; print &HoldError("user '$P{'username'}' already exist"); }
	print &ManageHtpasswdForm();
}
elsif (($P{'todo'} eq 'changeuserpass') and $P{'username'} and $P{'userpass'})
{
	print &Operation(qq{change password disabled in shareware version. <a href="http://www.indexsoft.com/passmanagerpro/">please register</a><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>});
	print &ManageHtpasswdForm();
}
elsif (($P{'todo'} eq 'deleteusers') and $P{'usersnames'})
{
	@USERS = split(/\0/,$P{'usersnames'});
	print &Operation("delete selected users");
	open (FILE, $PassFile);
	# from htpasswd
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		push (@LINES, $line) if (!grep ($_ eq $user, @USERS));
	}
	close(FILE);
	open (FILE, ">$PassFile") || print &HoldError("can not write to <i>$PassFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	# from htgroups
	$#LINES = -1;
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group, $user) = split(/\:/,$line);
		push (@LINES, $line) if (!grep ("$_\n" eq $user, @USERS));
	}
	close(FILE);
	open (FILE, ">$GroupFile") || print &HoldError("can not write to <i>$GroupFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print  FILE $_; }
	close(FILE);
	print &ManageHtpasswdForm();
}
elsif (($P{'todo'} eq 'disableusers'))
{
	@USERS = split(/\0/,$P{'usersnames2'});
	print &Operation("disable/enable selected users");
	open (FILE, $PassFile);
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		if (grep($_ eq $user, @USERS)) { ($user !~ /^#/)?push(@LINES, "#$line"):push(@LINES, "$line") }
		else { $line =~ s/^#//; push(@LINES, $line) }
	}
	close(FILE);
	open (FILE, ">$PassFile") || print &HoldError("can not write to <i>$PassFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	print &ManageHtpasswdForm();
}
elsif ($P{'todo'} eq 'managehtpasswd' or $P{'from'} eq 'managehtpasswd')
{
	print &ManageHtpasswdForm();
}
# all about manage .htgroups
elsif ($P{'todo'} eq 'changemembers' and $P{'groupname'})
{
	print &Operation(qq{change members of group disabled in shareware version.  <a href="http://www.indexsoft.com/passmanagerpro/">please register</a><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>});
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'viewmembers' and $P{'groupname'})
{
	print &Header("Select members of group $P{'groupname'}").qq{<form action="accessmanager.cgi" method="post">
	<input type="hidden" name="todo" value="changemembers">
	<input type="hidden" name="groupname" value="$P{'groupname'}"><ul>};
	open (FILE, $GroupFile);
	grep (do{chomp $_; ($group, $user) = split(/\:/,$_); $group =~ s/^#//; push (@GROUPUSERS, $user) if ($group eq $P{'groupname'} and $user);}, <FILE>);
	close(FILE);
	open (FILE, $PassFile);
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		($user =~ s/^#//)?($disabled = ' <i>(user disabled)</i>'):($disabled = '');
		print qq{<li><input type="checkbox" name="members" value="$user"}.((grep($_ eq $user, @GROUPUSERS))?' checked':'').qq{> $user$disabled<br>};
	}
	close(FILE);
	print '</ul><input type="submit" value="Change members"> <input type="Reset"></form>';
}
elsif ($P{'todo'} eq 'disablegroups')
{
	@GROUPS = split(/\0/,$P{'groupnames2'});
	print &Operation("disable/enable selected groups</p>");
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group,$user) = split(/\:/,$line);
		if (grep($_ eq $group, @GROUPS)) { ($group !~ /^#/)?push(@LINES, "#$line"):push(@LINES, "$line") }
		else { $line =~ s/^#//; push(@LINES, $line) }
	}
	close(FILE);
	open (FILE, ">$GroupFile") || print &HoldError("can not write to <i>$GroupFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'deletegroups' and $P{'groupnames'})
{
	@GROUPS = split(/\0/,$P{'groupnames'});
	print &Operation("delete selected groups");
	open (FILE, $GroupFile);
	foreach $line(<FILE>)
	{
		($group,$user) = split(/\:/,$line);
		$group =~ s/^#//;
		push (@LINES, $line) if (!grep ($_ eq $group, @GROUPS));
	}
	close(FILE);
	open (FILE, ">$GroupFile") || print &HoldError("can not write to <i>$GroupFile</i>");
	binmode('FILE');
	foreach (@LINES)	{ print FILE $_; }
	close(FILE);
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'addgroup' and $P{'groupname'})
{
	$P{'groupname'} =~ s/^#//;
	print &Operation("add new group <i>'$P{'groupname'}'</i>");
	open (FILE, $GroupFile);
	@GROUPS = <FILE>;
	close(FILE);
	if (!grep (($_ =~ /^$P{'groupname'}:.*$/ or $_ =~ /^#$P{'groupname'}:.*$/), @GROUPS))
	{
		open (FILE, ">>$GroupFile") || print &HoldError("can not write to <i>$GroupFile</i>");
		binmode('FILE');
		print FILE "$P{'groupname'}:\n";
		close(FILE);
	}
	else { print &HoldError("group '$P{'groupname'}' already exist"); }
	print &ViewGroupsInfo();
}
elsif ($P{'todo'} eq 'managehtgroups' or $P{'from'} eq 'managehtgroups')
{
	print &ViewGroupsInfo();
}
elsif (($P{'todo'} eq 'checkver'))
{
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=accessmanager&ver=$VER" width="550" height="100" marginwidth="0" marginheight="0" scrolling="no" frameborder="0">
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" src="http://www.indexsoft.com/checkver.px?program=accessmanager&ver=$VER&method=javascript"></SCRIPT>
	</iframe></p>};
}
else
{
	print &StartForm();
}
print &BottomOfPage();

#################################################################################
sub DirWalker
{
	my ($rootdir, $dir) = @_;
	my ($result, $file, $areaname, @files, @dirs);
	local *DIR;
	if (!$dir or !-d "$dir") { $dir = $rootdir }
	$result = &Header('Protect or change permission').qq{<p>Selected: <i>$dir</i><br>};
	if (-e "$dir$DirSeparator.htaccess")
	{
		$areaname = '';
		open (FILE, "$dir$DirSeparator.htaccess") || print &HoldError("can not open file <i>'$dir$DirSeparator.htaccess'</i>");
		foreach (<FILE>) { ($areaname .= $_) if ($_ ne "\n"); }
		close (FILE);
		if ($areaname =~ /AuthName "(.*)"/)	{ $result .= qq{Status: <i>Protected</i><br>Area name: <i>$1</i></p>} } else {$result .= qq{Status: <i>without access restriction</i></p>}}
		$result .= qq{<p>&#149; <a href="accessmanager.cgi?todo=edithtaccess&dir=$dir">change name of protected area or users permission to this directory</a><br>&#149; <a href="accessmanager.cgi?todo=unprotectdir&dir=$dir" onclick="return confirm('Are you sure you want to delete .htaccess file from current directory?\\nProtected area \\'$1\\' will be deleted!')">remove .htaccess file from this directory</a></p>}
	}
	else
	{
	 $result .= qq{Status: <i>Unprotected</i></p><form action="accessmanager.cgi" method="post"><input type="hidden" name="todo" value="edithtaccess"><input type="hidden" name="dir" value="$dir"><input type="submit" value="Protect it!"></form>}
	}
	$result .= &Header('Select another directory for protect');
	$result .= '<ul>';
	$dir =~ /^(.*)(\\|\/)/;
	$result .= qq{<li><a title="go to parent directory" href="accessmanager.cgi?todo=dirwalk&dir=$1"><b>..</b></a>} if ($rootdir ne $dir);
	opendir (DIR, $dir);
	while ($file = readdir(DIR)) { (-d "$dir$DirSeparator$file") ? push (@dirs, $file) : push (@files, $file) }
	@dirs = sort @dirs;
	@files = sort @files;
	foreach $file(@dirs)	{	$result .= qq{<li><a title="change current directory to '$file'" href="accessmanager.cgi?todo=dirwalk&dir=$dir$DirSeparator$file">$file</a>} if ($file ne '.' and $file ne '..') }
	foreach $file(@files)	{	($result .= qq{<li>$file}) }
	closedir(DIR);
	$result .= '</ul>';
	$result .= &Header('Create new directory').qq{<form action="accessmanager.cgi" method="post"><i>directory name:</i><br><input type="hidden" name="dir" value="$dir"><input type="hidden" name="todo" value="dirwalk"><input type="text" name="createdir"> <input type="submit" value="Create"></form>};
	return $result;
}

sub ManageUsersForm
{
	my ($dir, $htaccescontent) = @_;
	my ($privhosts, $group, $satisfy, $order, $host, $privusers, $line, $user, $pass, @htaccessusers, @htgroups, @htaccesshosts, @htpasswdusers, @hthosts, $result, $htTempls, $i);
	local *FILE;
	$htaccescontent =~ s/\r//g;
	# array for users from .htpasswd
	open (FILE, $PassFile);
	grep ( do{ ($user,$pass) = split(/\:/,$_); push (@htpasswdusers, $user); }, <FILE>);
	close(FILE);
	# array for groups
	open (FILE, $GroupFile);
	grep ( do{ ($group,$user) = split(/\:/,$_); push (@htgroups, $group) if (!grep($_ eq $group, @htgroups)); }, <FILE>);
	close(FILE);
	# array for hosts
	open (FILE, $HostFile);
	@hthosts = <FILE>;
	chomp @hthosts;
	close(FILE);
	#users
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^require user (.*)/)
		{
			$user = $1;
			push (@htaccessusers, $user);
			$privusers .= qq{<li><input type="checkbox" name="users" value="$user" checked>$user}.((!grep (($_ eq $user or $_ eq "#$user"), @htpasswdusers))?' <i>(user does not exist)</i>':'').((grep ($_ eq "#$user", @htpasswdusers))?' <i>(user disabled)</i>':'');
			$htaccescontent =~ s/$line\n//;
		}
		elsif ($line =~ /^AuthName (.*)/)
		{
			$areaname = $1;
			$areaname =~ s/\"//g;
			$htaccescontent =~ s/$line\n//;
		}
		elsif ($line =~ /^require valid-user$/)
		{
			$validuser = '1';
			$htaccescontent =~ s/$line\n//;
		}
	}
	foreach $user(@htpasswdusers)
	{
		($user =~ s/^#//)?($disabled = ' <i>(user disabled)</i>'):($disabled = '');
		if (!grep ($_ eq $user, @htaccessusers)) { $privusers .= qq{<li><input type="checkbox" name="users" value="$user">$user$disabled} }
	}
	$privusers .= qq{<li><input type="checkbox" name="validuser" value="1"}.($validuser?(' checked'):('')).qq{>Allow access for any valid user};
	#groups
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^require group (.*)/)
		{
			$group = $1;
			push (@htaccessgroups, $group);
			$privgroups .= qq{<li><input type="checkbox" name="groups" value="$group" checked>$group}.((!grep (($_ eq $group or $_ eq "#$group"), @htgroups))?' <i>(group does not exist)</i>':'').((grep ($_ eq "#$group", @htgroups))?' <i>(group disabled)</i>':'');
			$htaccescontent =~ s/$line\n//;
		}
	}
	foreach $group(@htgroups)
	{
		($group =~ s/^#//)?($disabled = ' <i>(group disabled)</i>'):($disabled = '');
		if (!grep ($_ eq $group, @htaccessgroups)) { $privgroups .= qq{<li><input type="checkbox" name="groups" value="$group">$group$disabled} }
	}
	#hosts
	$privhosts .= qq{<li><i>Alw</i> | <i>Dny</i>};
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^(Allow|Deny) from (.*)/)
		{
			$host = $2;
			push (@htaccesshosts, $host);
			$privhosts .= qq{<li><input onclick="Boxes(this.name,this.value)" type="checkbox" name="allowhosts" value="$host" title="Allow from"}.(($1 eq 'Allow')?(' checked'):('')).qq{> | <input onclick="Boxes(this.name,this.value)" type="checkbox" name="denyhosts" value="$host" title="Deny from"}.(($1 eq 'Deny')?(' checked'):('')).qq{> $host}.((!grep (($_ eq $host), @hthosts))?qq{ <i>(host does not exist; <a href="accessmanager.cgi?todo=addhost&hostname=$host">add</a>)</i>}:'');
			$htaccescontent =~ s/$line\n//;
		}
	}
	foreach $host(@hthosts)
	{
		if (!grep ($_ eq $host, @htaccesshosts)) { $privhosts .= qq{<li><input onclick="Boxes(this.name,this.value)" type="checkbox" name="allowhosts" value="$host" title="Allow from"> | <input onclick="Boxes(this.name,this.value)" type="checkbox" name="denyhosts" value="$host" title="Deny from"> $host}; }
	}
	# satisfy
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^Satisfy (.*)/)
		{
			$satisfy = $1;
			$htaccescontent =~ s/$line\n//;
		}
	}
	$satisfy = qq{<input type="radio" name="satisfy" value="all" title="Satisfy all"}.(($satisfy eq 'all')?(' checked'):('')).qq{> Grant access if user pass the host restriction and enter a valid username/password (default)<br><input type="radio" name="satisfy" value="any" title="Satisfy any"}.(($satisfy eq 'any')?(' checked'):('')).qq{> Grant access if user either pass the host restriction or enter a valid username/password<br><br>};
	# order
	foreach $line(split (/\n/, $htaccescontent))
	{
		if ($line =~ /^Order (.*)/)
		{
			$order = $1;
			$htaccescontent =~ s/$line\n//;
		}
	}
	$order = qq{<input type="radio" name="order" value="Allow,Deny" title="Order Allow,Deny"}.(($order eq 'Allow,Deny')?(' checked'):('')).qq{> Access is denied by default<br><input type="radio" name="order" value="Deny,Allow" title="Order Deny,Allow"}.(($order eq 'Deny,Allow')?(' checked'):('')).qq{> Access is allowed by default<br><br>};
	# templates for .htaccess
	$htaccessTempl0 = $htaccessTempl;
	$htaccessTempl0 =~ s/AuthName "(.*)"\n//g;
	$htTempls .= qq{<li><a href="#" onclick="InsertTemplate(9000); return false;"><b>Insert this template if you want to protect this directory</b></a><textarea name="templ9000" style="display:none;">$htaccessTempl0</textarea>} if(!$areaname);
  for ($i = 0; $i <= $#htTemplName; ++$i) 
	{
		$htTempls .= qq{<li><a href="#" onclick="InsertTemplate($i); return false;">$htTemplName[$i]</a><textarea name="templ$i" style="display:none;">$htTempl[$i]</textarea>};
	}
	$result = q{
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
  <!--
	function Boxes(ad,host)
	{
		for (var i=0;i<document.protectarea.elements.length;i++) { var z=document.protectarea.elements[i]; if (z.name == ad && ad == 'allowhosts' && z.value == host) { document.protectarea.elements[i+1].checked = false }; if (z.name == ad && ad == 'denyhosts' && z.value == host) { document.protectarea.elements[i-1].checked = false } }
	}
  function InsertTemplate(num)
	{
		var template;
		template = eval ('document.protectarea.templ' + num + '.value');
		document.protectarea.htaccessfile.value = document.protectarea.htaccessfile.value + template;
		//eval ('document.protectarea.templname' + num + '.disabled = "true"');//
	}
  //-->
  </SCRIPT>}.&Header("Protect: $dir").qq{<form action="accessmanager.cgi" name="protectarea" method="post">
	<input type="hidden" name="todo" value="protectdir">
	<input type="hidden" name="dir" value="$dir">
	<b>1.</b> <i>name of protected area:</i><br>
	<ul><input type="text" name="areaname" value="$areaname"></ul>
	<b>2.</b> <i>select groups which should have access to the current directory:</i><br>
	<ul>$privgroups</ul>
	<b>3.</b> <i>select users which should have access to the current directory:</i><br>
	<ul>$privusers</ul>
	<b>4.</b> <i>select hostnames to allow or deny access to the current directory:</i><br>
	<ul>$privhosts</ul>
	<b>5.</b> <i>Satisfy all / any:</i><br>
	$satisfy
	<b>6.</b> <i>Access is allowed / denied by default:</i><br>
	$order
	<b>7.</b> <i>click on template to insert it to .htaccess file:</i><br><br>
	<ul>$htTempls</ul>
	<b>8.</b> <i>edit .htaccess file if require:</i><br>
	<textarea cols="66" rows="15" name="htaccessfile" wrap="off" style="width=550px;">$htaccescontent\n</textarea><br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Protect it!"></td><td align="center"><input type="reset" value="Reset all changes"></td><td align="right"><input type="Submit" value="Remove protection"}.((!-e "$dir$DirSeparator.htaccess")?' disabled onclick="return false;"':qq{ onclick="if (confirm('Are you sure you want to delete .htaccess file from current directory?\\nProtected area \\'$areaname\\' will be deleted!')) { todo.value = 'unprotectdir' } else { return false; }"}).qq{></td></tr></table>
	</form>
	};
	return $result;
}

sub FindHtaccesFile
{
	my ($dir) = @_;
	local *DIR;
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		if ($file eq '.htaccess') { push (@htaccessDirs, qq{$dir}) }
		elsif (-d "$dir$DirSeparator$file" and $file ne '.' and $file ne '..') { &FindHtaccesFile("$dir$DirSeparator$file") if (!grep ($_ eq $file, split(',',$ExcludeDirs))) }
	}
	closedir(DIR);
}

sub StartForm
{
	my ($dir, $result, $protecteddirs, $areaname) = ('', '', '', '');
	local *FILE;
	@htaccessDirs = ();
	&FindHtaccesFile($WebRootDir);
	foreach $dir(@htaccessDirs)
	{
		$areaname = '';
		open (FILE, "$dir$DirSeparator.htaccess") || print &HoldError("can not open file <i>'$dir$DirSeparator.htaccess'</i>");
		foreach (<FILE>) { ($areaname .= $_) if ($_ ne "\n"); }
		close (FILE);
		if ($areaname =~ /\nAuthName "(.*)"/) {$areaname = $1} else {$areaname = '.htaccess without access restriction'};
		$protecteddirs .= qq{<li><a href="accessmanager.cgi?todo=edithtaccess&dir=$dir" title="}.($ShowAuthName?"$dir\">$areaname</a>":"$areaname\">$dir</a>");
	}
	$result = &Header('Protected directories').qq{
	<ul>
		$protecteddirs
		<li><a href="accessmanager.cgi?todo=dirwalk">protect new directory</a></li>
	</ul>
	};
	return $result;
}

sub ManageHtpasswdForm
{
	my ($result) = ('');
	my ($user, $realusername, $pass, $line);
	local *FILE;
	$result = qq{
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	function Boxes(z)
	{
		if (z == 'delete')
		{
			document.selectuser.todo.value = 'deleteusers';
			document.selectuser.submit.value = 'Delete users';
			document.selectuser.submit.disabled = false;
			for (var i=0;i<document.selectuser.elements.length;i++) { var z=document.selectuser.elements[i]; if (z.name == 'username' || z.name == 'usersnames2') { z.checked = false } }
		}
		if (z == 'change')
		{
			document.selectuser.todo.value = 'changeuserpass';
			document.selectuser.submit.value = 'Change password';
			document.selectuser.submit.disabled = false;
			for (var i=0;i<document.selectuser.elements.length;i++) { var z=document.selectuser.elements[i]; if (z.name == 'usersnames' || z.name == 'usersnames2') { z.checked = false } }
		}
		if (z == 'disable')
		{
			document.selectuser.todo.value = 'disableusers';
			document.selectuser.submit.value = 'Disable/enable users';
			document.selectuser.submit.disabled = false;
			for (var i=0;i<document.selectuser.elements.length;i++) { var z=document.selectuser.elements[i]; if (z.name == 'username' || z.name == 'usersnames') { z.checked = false } }
		}
	}
	//-->
	</SCRIPT>}.&Header('Select users for delete, disable/enable or change password').qq{
	<form name="selectuser" action="accessmanager.cgi" method="post">
	<input type="hidden" name="from" value="managehtpasswd">
	<input type="hidden" name="todo" value="">
	<ul>};
	open (FILE, $PassFile);
	$result .= qq{<li> <i>Del</i> | <i>D/E</i> | <i>CPwd</i>};
	foreach $line(<FILE>)
	{
		($user,$pass) = split(/\:/,$line);
		$realusername = $user;
		($realusername =~ s/^#//)?($disabled = ' <i>(user disabled)</i>'):($disabled = '');
		$result .= qq{<li><input type="checkbox" name="usersnames" value="$user" title="select for delete" onclick="Boxes('delete')"> | <input type="checkbox" name="usersnames2" value="$user" title="disable/enable" onclick="Boxes('disable')"}.(($disabled)?' checked':'').qq{> | <input type="radio" name="username" value="$user" onclick="Boxes('change')"}.(($disabled)?' disabled title="can not change password for disabled user"':' title="select for change password"').qq{> | $realusername$disabled };
	}
	close(FILE);
	$result .= qq{
	</ul>
	<i>change password for selected user:</i><br><input type="password" name="userpass"><br><br><input name="submit" type="submit" value="  first select action  " disabled> <input type="Reset"></form>}.&Header('Add user').qq{
	<p><form name="adduser" action="accessmanager.cgi" method="post">
	<input type="hidden" name="from" value="managehtpasswd">
	<input type="hidden" name="todo" value="adduser">
	<i>user name:</i><br><input type="text" name="username"><br><i>password:</i><br><input type="password" name="userpass"><br><br>	<input type="submit" value="Add user">
	</form></p>
	};
	return $result;
}

sub ManageHostsForm
{
	my ($result, $line) = ('','');
	local *FILE;
	$result .= &Header('Manage list of hosts').qq{<form name="selectgroup" action="accessmanager.cgi" method="post"><input type="hidden" name="from" value="managehosts"><input type="hidden" name="todo" value="deletehosts"><ul>};
	open (FILE, $HostFile);
	foreach $line(<FILE>)
	{
		chomp $line;
		$result .= qq{<li><input type="checkbox" name="hostnames" value="$line" title="select for delete"> $line}
	}
	close(FILE);
	$result .= q{</ul><input name="submit" type="submit" value="Delete hosts"> <input type="Reset"></form>};
	$result .= &Header('Add new host').qq{<form name="addhost" action="accessmanager.cgi" method="post"><input type="hidden" name="from" value="managehosts"><input type="hidden" name="todo" value="addhost">
	<i>host name or IP address:</i><br><input type="text" name="hostname" size="50" value="$ENV{'REMOTE_ADDR'}"> <input type="submit" value="Add host"></form>};
	return $result;
}

sub ViewGroupsInfo
{
	my ($result, $line, $group, $user, @groups);
	local *FILE;
	$result = qq{
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	function Boxes(z)
	{
		if (z == 'deletegroups')
		{
			document.selectgroup.todo.value = 'deletegroups';
			document.selectgroup.submit.value = 'Delete groups';
			document.selectgroup.submit.disabled = false;
			for (var i=0;i<document.selectgroup.elements.length;i++) { var z=document.selectgroup.elements[i]; if (z.name == 'groupnames2') { z.checked = false } }
		}
		if (z == 'disablegroups')
		{
			document.selectgroup.todo.value = 'disablegroups';
			document.selectgroup.submit.value = 'Disable/enable groups';
			document.selectgroup.submit.disabled = false;
			for (var i=0;i<document.selectgroup.elements.length;i++) { var z=document.selectgroup.elements[i]; if (z.name == 'groupnames') { z.checked = false } }
		}
	}
	//-->
	</SCRIPT>}.&Header('Select groups for delete, disable/enable or edit members list').qq{
	<form name="selectgroup" action="accessmanager.cgi" method="post">
	<input type="hidden" name="from" value="managehtgroups">
	<input type="hidden" name="todo" value=""><ul>};
	open (FILE, $GroupFile);
	$result .= qq{<li> <i>Del</i> | <i>D/E</i>};
	foreach $line(<FILE>)
	{
		($group,$user) = split(/\:/,$line);
		$realgroupname = $group;
		($realgroupname =~ s/^#//)?($disabled = ' <i>(group disabled)</i>'):($disabled = '');
		if (!grep($_ eq $group, @groups)) { push(@groups, "$group"); $result .= qq{<li><input type="checkbox" name="groupnames" value="$realgroupname" title="select for delete" onclick="Boxes('deletegroups')"> | <input type="Checkbox" name="groupnames2" value="$group" title="disable/enabe" onclick="Boxes('disablegroups')"}.($disabled?' checked':'').qq{> <a href="accessmanager.cgi?todo=viewmembers&groupname=$realgroupname" title="members of group $realgroupname">$realgroupname</a>$disabled}; }
	}
	close(FILE);
	$result .= q{</ul><input name="submit" type="submit" value="  first select action  " disabled> <input type="Reset"></form>}.&Header('Add new group').q{
	<form name="addgroup" action="accessmanager.cgi" method="post"><input type="hidden" name="from" value="managehtgroups"><input type="hidden" name="todo" value="addgroup">
	<i>group name:</i><br><input type="text" name="groupname"> <input type="submit" value="Add group"></form>};
	return $result;
}

sub EditConfigForm
{
	local *IN;
	my ($cfgfile, $nofile);
	open(IN, 'accessmanager.pm') || ($nofile = 1);
	grep ($cfgfile .= $_, <IN>);
	close IN;
	print &HoldError($configerror) if ($configerror and !$P{'autocfg'});
	if ($nofile or $P{'autocfg'})
	{
		print &Operation('generate configuration file automatically');
		$cfgfile = &CfgTemplate();
	}
	return &Header('Edit configuration file').qq{
	Document root directory: <i>$document_root</i><br>
	Install directory: <i>$installdir</i><br><br>
	&#149; <a href="accessmanager.cgi?todo=configure&autocfg=1" onclick="return window.confirm('Please confirm the action only if access manager does not work correctly or you run it at a first time.\\nAre you shure?')">Generate configuration file automatically</a><br>
	&#149; <a href="accessmanager.cgi?todo=configure&autocfg=1&upgrade=1" onclick="return window.confirm('This action will add new variables to configuration file if they does not exist, but do not overwrite defined variables.\\nAre you shure?')">Upgrade old version configuration file</a><br><br>
	<form action="accessmanager.cgi" method="post">
	<input type="hidden" name="todo" value="saveconfig">
	<textarea name="cfgfilecontent" cols="66" rows="15" wrap="off">$cfgfile</textarea><br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Save configuration file"></td><td  align="right"><input type="reset" value="Reset all changes"></td></tr></table>
	</form>};
}

sub CheckConfig
{
	eval('require "./accessmanager.pm"');
  return $@;
}

sub CfgTemplate
{
my $dirsep = '/'; $dirsep = '\\\\' if ($ENV{'WINDIR'});
my $DirSeparator = '/'; $DirSeparator = '\\' if ($ENV{'WINDIR'});
my $upg = $P{'upgrade'};
my ($result, $i);

my $htpaswd = 'NOT_DETECTED';
if (-e '\apache\bin\htpasswd.exe') { $htpaswd = '\apache\bin\htpasswd.exe' }
elsif (-e 'c:\apache\bin\htpasswd.exe') { $htpaswd = 'c:\apache\bin\htpasswd.exe' }
elsif (-e 'd:\apache\bin\htpasswd.exe') { $htpaswd = 'd:\apache\bin\htpasswd.exe' }
elsif (-e 'e:\apache\bin\htpasswd.exe') { $htpaswd = 'e:\apache\bin\htpasswd.exe' }
elsif (-e '\webshare\apache\bin\htpasswd.exe') { $htpaswd = '\webshare\apache\bin\htpasswd.exe' }
elsif (-e '/usr/local/apache/bin/htpasswd') { $htpaswd = '/usr/local/apache/bin/htpasswd' }
elsif (-e '/usr/local/bin/htpasswd') { $htpaswd = '/usr/local/bin/htpasswd' }
elsif (-e '/usr/apache/bin/htpasswd') { $htpaswd = '/usr/apache/bin/htpasswd' }
elsif (-e '/usr/local/httpd/bin/htpasswd') { $htpaswd = '/usr/local/httpd/bin/htpasswd' }
elsif (-e '/usr/httpd/bin/htpasswd') { $htpaswd = '/usr/httpd/bin/htpasswd' }

$result = q{# ATTENTION!!! AUTOMATICALLY GENERATED CONFIGURATION FILE
# PLEASE CHECK-UP CAREFULLY AND FILL IN ALL INDISPENSABLE VARIABLES

# empty for MD5 encryption (default) of the password or '-m', '-d', '-s' 
$Encryption = '}.(($Encryption and $upg)?("$Encryption"):('')).q{';

# complete path and file name of the .htpasswd file
$PassFile = '}.(($PassFile and $upg)?("$PassFile"):("$installdir$DirSeparator.htpasswd")).q{';

# complete path and file name of the .htgroups file - groups of users
$GroupFile = '}.(($GroupFile and $upg)?("$GroupFile"):("$installdir$DirSeparator.htgroups")).q{';

# complete path and file name of the .hosts file (with IP addresses or hosts)
$HostFile = '}.(($HostFile and $upg)?("$HostFile"):("$installdir$DirSeparator.hthosts")).q{';

# start path to a directory of a website to which contents you want to sets access restrictions), leave out trailing "\\" or "/"
$WebRootDir = '}.(($WebRootDir and $upg)?("$WebRootDir"):("$document_root")).q{';

# exclude this directories from scan (divided by a commas, if this directories will contain .htaccess file it will not displayed in protected directories list)
$ExcludeDirs = '}.(($ExcludeDirs and $upg)?("$ExcludeDirs"):('')).q{';

# full path and a name of the program which is delivered with distribution of Apache and which is intended for addition of new users and change of their passwords
$ChangeUserCommand = '}.(($ChangeUserCommand and $upg)?("$ChangeUserCommand"):("$htpaswd")).q{';

# $DirSeparator must be '\\\\' for windows of '/' for *nux 
$DirSeparator = '}.$dirsep.q{';

# default password for user administrator
$AdminPassword = '}.(($AdminPassword and $upg)?("$AdminPassword"):("administrator")).q{';

# if $ShowAuthName is equal to "1" instead of list of protected directories you will see the list of protected areas names. If it is "0" that list will contains protected directories
$ShowAuthName = '}.(($ShowAuthName and $upg)?("$ShowAuthName"):("0")).q{';

# templete of .htaccess file for new protected directories
$htaccessTempl = qq{#access restriction template\nAuthType Basic\nAuthAuthoritative on\nAuthName "Restricted"\nAuthUserFile $PassFile\nAuthGroupFile $GroupFile\n#/access restriction template\n};

# lists of names for fragments and frequently used fragments of .htaccess files};
if (($#htTemplName >= 0) and $upg)
{
for ($i = 0; $i <= $#htTemplName; ++$i) 
{
$htTempl[$i] =~ s/\n/\\n/g;
$result .= qq{
\$htTemplName[$i] = q{$htTemplName[$i]};
\$htTempl[$i] = qq{$htTempl[$i]};}
}
}
else
{
$result .= q{
$htTemplName[0] = 'Directory index files';
$htTempl[0] = "DirectoryIndex index.html index.cgi index.pl\n";
$htTemplName[1] = 'Allow scripts';
$htTempl[1] = "AddHandler cgi-script .pl .cgi\nOptions +ExecCGI\n";}
}

$result .= qq{\n\n1; # DO NOT DELETE THIS LINE};
return $result;
}

sub TopOfPage
{
	return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n<html>
	<head>
	<title>indexsoft access manager (ver. $VER)</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 0px; margin-bottom : 5px; }
		H4 { color : #5588BB; font-size : 16px; }
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; text-align: right;}
		body .small2 { font-size : 11px; text-align: left;}
	</style>
	</head>
	
	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft access manager (shareware)</h4><hr size="1" noshade>
	<p><a href="accessmanager.cgi">protected directories</a> | <a href="accessmanager.cgi?todo=dirwalk">protect new directory</a> | <a href="accessmanager.cgi?todo=managehtpasswd">manage users</a> | <a href="accessmanager.cgi?todo=managehtgroups">manage groups</a> | <a href="accessmanager.cgi?todo=managehosts">manage hosts</a></p>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>
	};
}

sub BottomOfPage
{
	return qq{</td></tr></table></td></tr></table><div class=small><a href="accessmanager.cgi?todo=configure">configuration file</a> | <a href="accessmanager.cgi?todo=checkver">check new version</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></div>
	<!------- Start of HTML Code ------->
	<form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST" target="_new"><input type="hidden" name="ID" value="16420"><table BORDER="0" CELLSPACING="0" bgcolor="#800000"><tr><td><table border="0" cellspacing="0" width="100%" bgcolor="#EFEFEF" cellpadding="3"><tr><td align="center"><font face="arial, verdana" size="2"><b>Rate Our Script @
  <a href="http://www.hotscripts.com">HotScripts.com</a></b></font></td><td align="center"><select name="ex_rate" size="1"><option selected>Select</option><option value="5" selected>Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select></td><td align="center"><input type="submit" value="Go!"></td></tr></table></td></tr></table></form>
	<!------- End of HTML Code ------->
	<!-- --------- Start of ScriptSearch Rating Code --------- -->
	<form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new">
	<input type="hidden" name="ID" value="5542">
	<table border="0" cellspacing="0">
	<tr><td align="center">
	<font face="arial, verdana" size="2"><b>please rate it! @ 
	<i><a href="http://www.scriptsearch.com/details/5542.html">ScriptSearch.com</a>
	</i></b></font></td></tr>
	<tr><td align=center>
	<select name="rate" size="1" style="font-size:10px;">
	<option value="--">- Select -</option>
	<option value="5" selected>Excellent!</option>
	<option value="4">Very Good</option>
	<option value="3">Good</option>
	<option value="2">Fair</option>
	<option value="1">Poor</option>
	</select> 
	<input type="submit" value="Vote!" style="font-size:10px;">
	</td></tr></table>
	</form>
	<!-- --------- End of ScriptSearch Rating Code --------- -->
	<hr size="1" noshade>
	<p><font size="1">(note: rating forms removed from full version)</font></p>
	</td></tr></table></body></html>};
}

sub Operation
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#C3D5E7"><tr><td valign="top" width="1%"><b>Action:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub Header
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>$_[0]</td></tr></table></td></tr></table>};
}

sub HoldError
{
	return qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Error occured!')\n//-->\n</SCRIPT>\n<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#FFCDCD"><tr><td valign="top" width="1%"><b>Error:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); }
}

